# Error Codes

This page contains all the error codes that the launcher may display.

---

| Code                                                                                | Description                                                                                                               | Possible solution                                                                                                                                                                                                      |
|-------------------------------------------------------------------------------------|---------------------------------------------------------------------------------------------------------------------------|------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
| 10048                                                                               | Something else is already using the launcher port                                                                         | Make sure to only have ONE instance of the BeamMP-Launcher running at a time. Try restarting your PC.
| 10038 / 10060 / 10061                                                               | No Server answered on this specified IP and / or port                                                                     | If you are the server owner, please check the port forwarding and/or firewall rules found at [BeamMP-Server](https://docs.beammp.com/server/create-a-server). If you are not the server owner, choose a different server or contact the owner if known.
| 10054                                                                               | Connection reset by peer                                                                                                  | The server you're connecting to has gone offline.                                                                                                                                                                      |
| Failed to find the game please launch it. Report this if the issue persists code 3. | The launcher was unable to find the game's info (game directory, profile directory, version ect...) in the registry entry | Run the game at least once so the registry values get created.                                                                                                                                                         |
| Failed to find the game please launch it. Report this if the issue persists code 4. | The launcher was unable to read the game's info (game directory, profile directory, version ect...) in the registry entry | This error is most likely to appear in users with **pirated copies** of the game. If you have bought the game, run it at least once so the registry values get created.                                                |
| Failed to Launch the game! launcher closing soon                                    | The launcher was unable to find the game's executable                                                                     | Run the game at least once before running the launcher again.                                                                                                                                                          |
| Game Closed! launcher closing soon                                                  | The game was closed                                                                                                       | This message will appear on game closure or when the game failed to start.                                                                                                                                             |
| Launcher Update failed!                                                             | The launcher failed to download a new version                                                                             | Check your internet connection and firewall / antivirus rules so that the launcher is not blocked.                                                                                                                     |
| Logger file init failed                                                             | The launcher does not have the ability to create files                                                                    | Run the launcher as administrator.                                                                                                                                                                                     |
| Please close the game and try again                                                 | The game is already open and the launcher can't clear the `multiplayer/mods` folder                                       | Close the game and retry.                                                                                                                                                                                              |
| Please launch the game at least once                                                | The launcher tried and failed to modify the game's directory                                                              | Run the game at least once before running the launcher again.                                                                                                                                                          |
| Primary Servers Offline! Sorry for the inconvenience!                               | The launcher failed to check for an update                                                                                | Check your internet connection and firewall rules. If there is no problem on your end, please check the [BeamMP updates channel](<https://discord.com/channels/601558901657305098/697596153943949352>) on our Discord. |
| Sorry Backend System Outage! Don't worry it will back on soon!                      | The BeamMP backend did not respond                                                                                        | Check your internet connection and firewall rules. If there is no problem on your end, please check the [BeamMP updates channel](<https://discord.com/channels/601558901657305098/697596153943949352>) on our Discord. |
| Stuck on updating                                                                   | The launcher is stuck on updating and will not continue to the next step                                                  | Run the launcher as administrator and check your antivirus rules so that the launcher is not blocked.                                                                                                                  |

If the launcher closes immediately, check the `Launcher.log` file in the folder where you installed BeamMP.
