# Codes d'erreurs

Cette page contient tout les codes d'erreurs que le lanceur peut afficher.

---

| Code                                                                                | Description                                                                                                               | Solution possible                                                                                                                                                                                                      |
|-------------------------------------------------------------------------------------|---------------------------------------------------------------------------------------------------------------------------|------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
| 10048                                                                               | Quelque chose d'autre utilise le port du lanceur                                                                               | Assurez-vous que le lanceur n'est executé qu'une seule fois. Essayer de redémarer votre ordinateur.
| 10038 / 10060 / 10061                                                               | Aucun serveur n'a répondu sur cette adresse IP et / ou port                                                                                  | Si vous êtes le propriétaire du serveur, vérifiez la redirection de port et/ou les règles du parefeu, les deux peuvent être retrouvé dans [Serveur BeamMP](https://docs.beammp.com/server/create-a-server). Si vous n'êtes pas le propriétaire du serveur, choisissez un serveur different ou contacter le propriétaire du serveur si vous le connaissez.
| 10054                                                                               | La connexion a été réinitialisée par un homologue                                                                             | Le serveur auquel vous tentez de vous connecter est hors ligne.                                                                                                                                                                   |
| Failed to find the game please launch it. Report this if the issue persists code 3. | Le lanceur n'a pas été capable the trouver les infos du jeu (répertoire du jeu, répertoire de profils, version, ect...) dans le registre.                        | Lancez le jeu au moins une fois pour que les valeurs du registre puissent être créées.                                                                                                                                                         |
| Failed to find the game please launch it. Report this if the issue persists code 4. | Le lanceur n'a pas été capable the trouver les infos du jeu (répertoire du jeu, répertoire de profils, version, ect...) dans le registre. | Cette erreur apparait surtout si l'utilisateur a une copie piratée du jeu. Si vous avez acheté le jeu, lancer le au moins une fois pour que les valeurs du registre puissent être créées.                                                |
| Failed to Launch the game! launcher closing soon                                    | Le lanceur n'a pas été capable the trouver l'exécutable (.exe) du jeu                                                                                   | Lancer le jeu au moins une fois avant the lancer BeamMP.                                                                                                                                                          |
| Game Closed! launcher closing soon                                                  | Le jeu a été fermé                                                                                 | Ce message apparait lorsque le jeu est fermé ou lorsque le jeu ne réussit pas à se lancer.                                                                                                                                             |
| Launcher Update failed!                                                             | Le lanceur n'a pas réussit à télécharger une nouvelle version                                                                                | Vérifiez votre conection internet, les règles de votre parefeu et de votre antivirus et assurez vous que BeamMP n'est pas bloqué.                                                                                                                     |
| Logger file init failed                                                             | Le lanceur ne peut pas créer de fichiers                                                                              | Exécuter le lanceur en tant qu'administrateur.                                                                                                                                                                                     |
| Please close the game and try again                                                 | Le jeu est déjà lancé et le lanceur ne peut pas nettoyer le dossier `multiplayer/mods`                                                                                 | Fermez le jeu et réessayer.                                                                                                                                                                                              |
| Lancer le jeu au moins une fois.                                                    | Le lanceur a tenté de modifier les fichiers du répertoir du jeu et a échoué                                                                                | Lancer le jeu au moins une fois avant the lancer BeamMP.                                                                                                                                                                                  |
| Primary Servers Offline! Sorry for the inconvenience!                               | Le lanceur n'a pas réussit à vérifier si il y a une mise à jour                                                                                  | Vérifiez votre conection internet et les règles de votre parefeu. Si il n'y a pas de problème de votre côté, vérifiez ce canal [BeamMP updates channel](<https://discord.com/channels/601558901657305098/697596153943949352>) sur notre Discord. |
| Sorry Backend System Outage! Don't worry it will back on soon!                      | Le backend (infrastructure en arrière plan) n'a pas répondu                                                                                        |  Vérifiez votre conection internet et les règle de votre parefeu. Si il n'y a pas de problème de votre côté, vérifiez ce canal [BeamMP updates channel](<https://discord.com/channels/601558901657305098/697596153943949352>) sur notre Discord. |
| Stuck on updating                                                                   | Le lanceur est bloqué sur updating et ne progressera pas à la prochaine étape                                                                                 | Exécuter le lanceur en tant qu'administrateur, vérifier les règles de votre antivirus et assurez-vous que le lanceur ne soit pas bloqué.                                                                                                       |

Si le lanceur se ferme immédiatement, vérifiez le fichier `Launcher.log` dans le dossiers où vous avez installé BeamMP.
