---
hide:
  - navigation
---
# BeamMP Community Rules

!!! info
    BeamMP Staff are not bound to moderate strictly by these rules and may operate at their own discretion. In addition to these rules, Discord's [Community Guidelines](https://discord.com/guidelines/) and [Terms of Service](https://discord.com/terms/) apply, and are enforced.

## BeamMP General Rules (Applies to Discord, Forum and In-Game)

1. No Discrimination (e.g. sexism, racism, etc…) :material-information-outline:{ title="This includes using racial/sexual slurs or other vocabulary used to target an individual or group of people, either directly or with the intention of doing so." }
2. No Bullying or Harassment :material-information-outline:{ title="This includes targeting individuals with the use of unwanted actions, unsolicited DM's or targeting them with messages, images or verbal communication." }
3. No NSFW, Offensive or Malicious Content :material-information-outline:{ title="This includes content containing malicious links, nudity, pornography, excessive profanity, or material otherwise offensive, malicious and/or otherwise not suitable for public spaces." }
4. No Spamming Text/Voice Channels or Posts :material-information-outline:{ title="This includes generating multiple posts or threads, spamming the same or similar messages and abusing voice communication channels or other actions that include join/leave spamming." }
5. Speak English :material-information-outline:{ title="All communication within BeamMP should be in the English language where possible, except in specific areas designated otherwise." }
6. No Inappropriate Profiles :material-information-outline:{ title="This includes profile names, photos, bios or other user-controlled content that doesn't align with BeamMP/BeamNG/Discord rules and ToS." }
7. No Doxxing :material-information-outline:{ title="No publishing of personal information (“doxing”) (including, but not limited to, real names, addresses, emails, passwords, bank account and credit card information, etc...)." }
8. No Politics :material-information-outline:{ title="This includes discussing past or current world events outside of BeamMP/BeamNG or gaming as a whole. There are places for valid discussion of these topics but BeamMP is not one of them." }
9. No advertising Non-BeamMP/BeamNG Content :material-information-outline:{ title="This includes non-BeamMP communities, social media channels or other external links.  This applies to posting within the BeamMP community, as well as sending users unsolicited DM's for the purpose of personal advertising." }
10. No Impersonating Staff :material-information-outline:{ title="This includes claiming to be a staff member of BeamMP, or claiming to have the abilities associated with being a staff member. This also includes the imitation of staff members." }
11. No Exploitation :material-information-outline:{ title="This includes exploiting any bugs or oversights for personal gain or to negatively impact the experience of others." }
12. Follow all given TOS :material-information-outline:{ title="This is important as restrictions such as the Discord age restriction (13+) must also be followed to use our Discord server." }
13. Respect Everyone :material-information-outline:{ title="This should go unsaid, but you need to have respect for everyone around you and act accordingly." }
14. Keep to the topic of the category or channel. :material-information-outline:{ title="This should go unsaid, but keep your content on the topic of the area that you are posting within. E.g. support should helping people or used when seeking support." }
15. No excessive CAPS LOCK or Reactions/Emojis :material-information-outline:{ title="Users should refrain from using excessive caps or emojis/reactions as not to obscure the point at hand." }
16. Check the [BeamMP FAQ](../../support/player-faq.md) & [BeamMP Community FAQ](https://forum.beammp.com/c/faq/35) before posting in support areas.

## Discord Rules

1. All Above Rules Apply Here :material-information-outline:{ title="All rules mentioned in this document apply to the voice chats." }
2. Follow Discord ToS & Guidelines :material-information-outline:{ title="Follow all rules outlined by Discord in their ToS and Guidelines" }
3. No NSFW Audio/Streams :material-information-outline:{ title="Players should not stream any content that violates BeamMP rules stated in Section 1 of this document." }
4. No Excessive Audio :material-information-outline:{ title="The excessive use of soundboards, playing music loudly or other uses of audio channels to intentionally agitate or target others is not allowed." }
5. No Join/Leave Spamming :material-information-outline:{ title="Most users will have sound effects enabled, do not join and leave chats rapidly." }
6. No Badgering Others (`@'ing`) :material-information-outline:{ title="This includes asking others repeatedly for a response after being ignored or told no." }
7. Keep bot commands in command specific channels
8. No Role-Playing :material-information-outline:{ title="This is in place to prevent issues arising due to missing context or to prevent users from circumventing certain rules." }

## How to appeal actions against you:

### Ban appeals may be submitted at <a href="https://docs.google.com/forms/d/1MaTPKM-MHQU5lUtxeOKz3C7OoI6Xbu5RX5AJdX-UOz4" class="inline-onebox">Ban Appeal - BeamMP</a>.

All ban appeals are investigated thoroughly, involving at least two (2) members of the staff/moderation team that were not involved in the case-at-hand.  The issuing staff member will be allowed to comment, but will not be otherwise involved in the appeal decision.  These appeal outcomes are final. BeamMP reserves the right to allow or not allow members as they deem appropriate according to the BeamMP Community Rules (as above), [Discord ToS](https://discord.com/terms), and other factors. 

!!! warning
    In the event of action taken against you, you are prohibited from creating a new Discord or BeamMP account to circumvent the ban.