# F.A.Q.
Liste de questions fréquentes et problèmes connus.

---
## **Client**

---
### **Comment installer BeamMP?**

Il y a un guide complet qui explique comment installer BeamMP sur Windows, vous pouvez le trouver [ici](https://docs.beammp.com/game/getting-started/).

---
### **Est-ce que BeamMP fonctionne avec une version piratée ou dépassée de BeamNG.drive?**

BeamMP ne fonctionnera pas avec une version piratée ou dépassée de BeamNG.drive.
L'équipe de soutient de BeamMP n'offre pas de soutient pour les versions piratées ou dépasées.

---
### **Est-ce que BeamMP fonction sur linux?**

Le client n'est pas officiellement supporté sur linux, cependant, vous pouvez suivre notre [guide qui explique comment utiliser BeamMP sur Linux](../game/getting-started/#2b-linux-installation)

---
### **Pourquoi le lanceur est détecté comme un virus par mon antivuris ou par Windows Defender**

Certains logiciels antivirus pourrait identifier BeamMP comme une menace puisqu'il interact avec le réseau et d'autres aspects. Il y a **aucun virus** dans le code. Le code pour le lanceur, le serveur, et le client lua peut être trouvé sur notre [GitHub](https://github.com/BeamMP).

---
### **J'ai une baisse de performances en jeu, que puis-je faire?**

Nous travaillons sans relâche pour rendre l'expérience multijoueur aussi stable que posible. Si vous avez déjà diminué vos paramètres graphiques et les performances sont encore mauvaises, envisager de jouer sur un serveur avec moins de joueurs. Le jeu est principalement dépendant du CPU lorsque vous jouez avec plusieurs persones, les CPU plus ancients (Même quadcore) vont donc avoir plus de difficultée à suivre qu'avec moins de joueurs. (En général: 1 voiture par fil(Thread) de CPU)

---
## **Divers**

---
### **Où est-ce que je peux trouver le code?**

Le code source en entier peut être retouvé sur notre [GitHub](https://github.com/BeamMP).
Avant de faire n'importe quel changement, souvenez-vous que le code est assujettit à nos  [Conditions d'utilisation](https://forum.beammp.com/t/terms-of-use-v1-0/43) et licenses:

|   Code     | License                                                                    |
|------------|:--------------------------------------------------------------------------:|
| Serveur     | [LICENSE](https://github.com/BeamMP/BeamMP-Server/blob/master/LICENSE)     |
| Lanceur   | [LICENSE](https://github.com/BeamMP/BeamMP-Launcher/blob/master/LICENSE) |
| Client Lua | [LICENSE](https://github.com/BeamMP/BeamMP/blob/development/LICENSE)    |

---
### **J'ai trouvé un bug ou un exploit, que dois-je faire?**

Si le problème est en lien avec le code et que vous savez utiliser Github, ouvrez une nouvelle "issue" (en anlgais) dans le répertoire approprié sur notre [GitHub](https://github.com/BeamMP). Nous utilisons un rythme de travail basée sur les "issue" donc même si vous avez une solution au problème, ouvrez une nouvelle "issue" et un "pull request" qui contient la solution au problème. PLus d'information sur comment contribuer peut être trouvé [ici](https://github.com/BeamMP/BeamMP/blob/development/CONTRIBUTING.md).

Si vous n'avez pas de compte Github, ne savez pas comment utiliser Github ou si vous avez une n'importe quelle autre question, vous pouvez entrer en contact avec nous de ces deux façons:

- Si c'est quelque chose qui n'est pas sensible/personel, vous pouvez créer un post sur notre [Forum BeamMP](https://forum.beammp.com) ou vous pouvez le signaler sur notre [Discord Officiel](https://discord.gg/beammp).
- Si l'information est sensible/personelle, vous pouvez signaler le problème directement à un(e) membre de notre équipe (Staff) sur notre [Discord](https://discord.gg/beammp).
